<ui:composition xmlns:s="http://jboss.org/schema/seam/taglib" xmlns:gdk="http://www.ihe.net/gazellecdk"
                xmlns:h="http://java.sun.com/jsf/html" xmlns:rich="http://richfaces.org/rich"
                xmlns:f="http://java.sun.com/jsf/core" xmlns:a4j="http://richfaces.org/a4j"
                xmlns:ui="http://java.sun.com/jsf/facelets" xmlns:g="http://www.ihe.net/gazelle"
                xmlns="http://www.w3.org/1999/xhtml">
    <!-- parameters: browserBean (extends testInstanceBrowser) -->
    <h:form id="browserform">
        <h:inputHidden id="filterUrlParameters" name="filterUrlParameters" value="#{browserBean.filter.urlParameters}"/>
        <script>
            updateUrl("browserform:filterUrlParameters");
            jq162("#browserform\\:filterUrlParameters").bind('change',
                    function () {
                        updateUrl("browserform:filterUrlParameters");
                    });
        </script>
        <a4j:queue requestDelay="300" ignoreDupResponses="true"/>

        <h:panelGroup rendered="#{displayFilter}">
            <ui:decorate template="/layout/panels/_panel_filter_criteria.xhtml">
                <div class="form-horizontal">
                    <div class="row">
                        <div class="col-md-6">
                            <ui:include src="/filter/filter.xhtml">
                                <ui:param name="filter" value="#{browserBean.filter}"/>
                                <ui:param name="filterId" value="tlsTestCase"/>
                                <ui:param name="filterName" value="#{messages['net.ihe.gazelle.atna.TestCase']}"/>
                                <ui:param name="filterForm" value="browserform"/>
                            </ui:include>
                            <ui:include src="/filter/filter.xhtml">
                                <ui:param name="filter" value="#{browserBean.filter}"/>
                                <ui:param name="filterId" value="runBy"/>
                                <ui:param name="filterName" value="#{messages['net.ihe.gazelle.atna.RunBy']}"/>
                                <ui:param name="filterForm" value="browserform"/>
                            </ui:include>
                            <ui:include src="/filter/filterDate.xhtml">
                                <ui:param name="filter" value="#{browserBean.filter}"/>
                                <ui:param name="filterId" value="timestamp"/>
                                <ui:param name="filterName" value="#{messages['net.ihe.gazelle.proxy.Timestamp']}"/>
                                <ui:param name="filterForm" value="browserform"/>
                            </ui:include>
                        </div>
                        <div class="col-md-6">
                            <ui:include src="/filter/filter.xhtml">
                                <ui:param name="filter" value="#{browserBean.filter}"/>
                                <ui:param name="filterId" value="sutHost"/>
                                <ui:param name="filterName" value="#{messages['net.ihe.gazelle.atna.SUTHost']}"/>
                                <ui:param name="filterForm" value="browserform"/>
                            </ui:include>
                            <ui:include src="/filter/filter.xhtml">
                                <ui:param name="filter" value="#{browserBean.filter}"/>
                                <ui:param name="filterId" value="verdict"/>
                                <ui:param name="filterName" value="#{messages['net.ihe.gazelle.atna.Verdict']}"/>
                                <ui:param name="filterForm" value="browserform"/>
                            </ui:include>
                        </div>
                    </div>
                </div>
                <ui:define name="filter_buttons">
                    <a4j:commandLink title="#{messages['net.ihe.gazelle.proxy.Refresh']}"
                                     actionListener="#{browserBean.refresh()}" render="browserform">
                        <span class="fa fa-refresh"></span>
                    </a4j:commandLink>
                    <a4j:commandLink title="#{messages['net.ihe.gazelle.atna.ResetCriteria']}"
                                     actionListener="#{browserBean.reset()}" render="browserform">
                        <span class="fa fa-times-circle"></span>
                    </a4j:commandLink>
                </ui:define>
            </ui:decorate>
        </h:panelGroup>

        #{dataTableStateHolder.setDescendingOn('lastChanged')}
        <rich:dataTable id="testInstancesTable" value="#{browserBean.instances}" var="instance"
                        rows="#{dataScrollerMemory.numberOfResultsPerPage}" render="testInstanceDS">
            <rich:column>
                <f:facet name="header">
                    <h:outputText value="#{messages['net.ihe.gazelle.proxy.Id']}"/>
                </f:facet>
                <h:outputLink target="_blank" value="#{browserBean.getPermanentLink(instance)}">
                    #{instance.id}
                </h:outputLink>
            </rich:column>
            <g:column sortBy="#{'lastChanged'}" sortOrder="#{dataTableStateHolder.sortOrders['lastChanged']}">
                <ui:define name="header">
                    <h:outputText value="#{messages['net.ihe.gazelle.proxy.Timestamp']}"/>
                </ui:define>
                <g:date value="#{instance.lastChanged}"/>
            </g:column>
            <rich:column>
                <f:facet name="header">
                    <h:outputText value="#{messages['net.ihe.gazelle.atna.RunBy']}"/>
                </f:facet>
                <s:div>
                    <h:outputText value="#{browserBean.getUserName(instance.lastModifierId)}"/>
                </s:div>
            </rich:column>
            <rich:column>
                <f:facet name="header">
                    <h:outputText value="#{messages['net.ihe.gazelle.atna.SUT']}"/>
                </f:facet>
                <s:div>
                    <h:outputText value="#{instance.sutHost}"/>
                    <h:outputText value=":"/>
                    <h:outputText value="#{instance.sutPort}"/>
                </s:div>
            </rich:column>
            <rich:column>
                <f:facet name="header">
                    <h:outputText value="#{messages['net.ihe.gazelle.atna.Verdict']}"/>
                </f:facet>
                <span class="#{browserBean.getVerdictIcon(instance.testVerdict)}"></span>
                <h:outputText value="#{instance.testVerdict}"/>
            </rich:column>
            <rich:column>
                <f:facet name="header">#{messages['net.ihe.gazelle.atna.Actions']}</f:facet>
                <a4j:commandLink action="#{browserBean.setPendingInstance(instance)}"
                                 title="#{messages['net.ihe.gazelle.atna.ViewInstanceDetails']}"
                                 oncomplete="jq162('#instanceView').modal('show');" render="instanceViewContent">
                    <span class="fa fa-search"></span>
                </a4j:commandLink>
            </rich:column>

            <f:facet name="footer">
                <ui:include src="/util/datatableFooter.xhtml">
                    <ui:param name="dataScrollerId" value="testInstanceDS"/>
                    <ui:param name="dataTableId" value="testInstancesTable"/>
                </ui:include>
            </f:facet>

        </rich:dataTable>

        <ui:decorate template="/layout/popup/_popup_title_footer.xhtml">
            <ui:param name="popup_id" value="instanceView"/>
            <ui:param name="styleClass" value="modal-lg"/>
            <ui:define name="popup_title">#{messages['net.ihe.gazelle.atna.TestInstanceDetails']}</ui:define>

            <s:div id="instanceViewContent">
                <ui:include src="/testinstance/viewPanel.xhtml">
                    <ui:param name="testInstance" value="#{browserBean.pendingInstance}"/>
                    <ui:param name="browserBean" value="#{browserBean}"/>
                </ui:include>
            </s:div>

            <ui:define name="popup_footer">
                <a4j:commandButton value="#{messages['net.ihe.gazelle.atna.Close']}" styleClass="gzl-btn"
                                   action="#{browserBean.setPendingInstance(null)}" execute="@this"
                                   oncomplete="jq162('#instanceView').modal('hide');"/>
            </ui:define>
        </ui:decorate>

    </h:form>
</ui:composition>
